
/**
 *	S3C (Simple Server-side Cache)
 *	Server-side Object Caching Framework 
 *
 *	Copyright (C) 2005  Kamran Zafar
 *
 *	This program is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU General Public License
 *	as published by the Free Software Foundation; either version 2
 *	of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *	Contact Info:
 *	Email: xeus.man@gmail.com
 */

package xeus.s3c;

import java.util.Collection;

import xeus.s3c.event.CacheListener;
import xeus.s3c.exception.SlotNotAvailableException;

/**
 * @author Kamran Zafar
 *
 */
public interface Cache{
    public Slot register(String slot) throws SlotNotAvailableException;
    public Slot register(String slot,int sTimeout) throws SlotNotAvailableException;
    public void unregister(String slot) throws SlotNotAvailableException;
    public Slot lookup(String slot) throws SlotNotAvailableException;
    public void invalidate();
    public void updated();
    public void addCacheListener(CacheListener listener);
    public void removeCacheListener(CacheListener listener);
    public Collection slots();
    //public void setName(String name);
    public String getName();
}

